'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _express = require('express');

var _naroujs = require('naroujs');

var _naroujs2 = _interopRequireDefault(_naroujs);

var _scrapeNarou = require('scrape-narou');

var _scrapeNarou2 = _interopRequireDefault(_scrapeNarou);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function () {
  var middleware = (0, _express.Router)();

  middleware.get('/toc/:ncode', function (req, res) {
    return _scrapeNarou2.default.tocR18(req.params.ncode).then(function (result) {
      return res.json(result);
    }).catch(function (error) {
      return res.status(403).json({ error: error.message });
    });
  });
  middleware.get('/novel/:ncode/:number', function (req, res) {
    return _scrapeNarou2.default.r18(req.params.ncode, req.params.number).then(function (result) {
      return res.json(result);
    }).catch(function (error) {
      return res.status(403).json({ error: error.message });
    });
  });
  middleware.get('/novel/:ncode', function (req, res) {
    return _scrapeNarou2.default.r18(req.params.ncode, 1).then(function (result) {
      return res.json(result);
    }).catch(function (error) {
      return res.status(403).json({ error: error.message });
    });
  });
  middleware.get('/shortstory/:ncode', function (req, res) {
    return _scrapeNarou2.default.r18(req.params.ncode).then(function (result) {
      return res.json(result);
    }).catch(function (error) {
      return res.status(403).json({ error: error.message });
    });
  });

  middleware.get('/', function (req, res) {
    return _naroujs2.default.r18(req.query).then(function (result) {
      return res.json(result);
    }).catch(function (error) {
      return res.status(403).json({ error: error.details });
    });
  });
  middleware.get('/:word', function (req, res) {
    _naroujs2.default.r18(_extends({}, req.params, req.query)).then(function (result) {
      return res.json(result);
    }).catch(function (error) {
      return res.status(403).json({ error: error.details });
    });
  });

  return middleware;
};

module.exports = exports['default'];
//# sourceMappingURL=create-r18-middleware.js.map