'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _express = require('express');

var _naroujs = require('naroujs');

var _naroujs2 = _interopRequireDefault(_naroujs);

var _scrapeNarou = require('scrape-narou');

var _scrapeNarou2 = _interopRequireDefault(_scrapeNarou);

var _createR18Middleware = require('./create-r18-middleware');

var _createR18Middleware2 = _interopRequireDefault(_createR18Middleware);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function () {
  var options = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];

  var middleware = (0, _express.Router)();

  if (options.r18) {
    middleware.use('/r18/', (0, _createR18Middleware2.default)());
  } else {
    middleware.use('/r18/', function (req, res) {
      res.status(403).json({ error: 'このAPIは禁止されています' });
    });
  }

  middleware.get('/toc/:ncode', function (req, res) {
    return _scrapeNarou2.default.toc(req.params.ncode).then(function (result) {
      return res.json(result);
    }).catch(function (error) {
      return res.status(403).json({ error: error.message });
    });
  });
  middleware.get('/novel/:ncode/:number', function (req, res) {
    return (0, _scrapeNarou2.default)(req.params.ncode, req.params.number).then(function (result) {
      return res.json(result);
    }).catch(function (error) {
      return res.status(403).json({ error: error.message });
    });
  });
  middleware.get('/novel/:ncode', function (req, res) {
    return (0, _scrapeNarou2.default)(req.params.ncode, 1).then(function (result) {
      return res.json(result);
    }).catch(function (error) {
      return res.status(403).json({ error: error.message });
    });
  });

  middleware.get('/shortstory/:ncode', function (req, res) {
    return (0, _scrapeNarou2.default)(req.params.ncode).then(function (result) {
      return res.json(result);
    }).catch(function (error) {
      return res.status(403).json({ error: error.message });
    });
  });

  middleware.get('/rank/:rtype', function (req, res) {
    return _naroujs2.default.rank({ rtype: req.params.rtype }).then(function (result) {
      return res.json(result);
    }).catch(function (error) {
      return res.status(403).json({ error: error.message });
    });
  });
  middleware.get('/fame/:ncode', function (req, res) {
    return _naroujs2.default.fame({ ncode: req.params.ncode }).then(function (result) {
      return res.json(result);
    }).catch(function (error) {
      return res.status(403).json({ error: error.message });
    });
  });

  middleware.get('/', function (req, res) {
    return (0, _naroujs2.default)(req.query).then(function (result) {
      return res.json(result);
    }).catch(function (error) {
      return res.status(403).json({ error: error.details });
    });
  });
  middleware.get('/:word', function (req, res) {
    (0, _naroujs2.default)(_extends({}, req.params, req.query)).then(function (result) {
      return res.json(result);
    }).catch(function (error) {
      return res.status(403).json({ error: error.details });
    });
  });

  return middleware;
};

module.exports = exports['default'];
//# sourceMappingURL=index.js.map